import {sandBox} from './sandBox'
import { getUrl } from './myapp';
export const is = {
	env() {
		return process.env.NODE_ENV
	},
	has(val) {
		return !!val;
	},
	isNum(val){
		return val && /^[0-9]$/.test(val);
	},
	not(val) {
		return !val;
	},
	empty(val) {
		return val === '';
	},
	age(val){
		return val && /^[0-9]{1,2}$/.test(val);
	},
	equal(v1, v2) {
		return v1 === v2;
	},
	qq(val) {
		return val &&　/^[1-9]\d{4,12}$/.test(val);
	},
	name(val) {
		return val &&　/^[A-Za-z0-9\u4E00-\u9FA5_]{2,10}$/.test(val);
	},
	///^[1][3,4,5,7,8][0-9]{9}$/
	// mobile(val) {
	// 	return val && /^(?=\d{11}$)^1(?:3\d|4[57]|5[^4\D]|66|7[^249\D]|8\d|9[89])\d{8}$/.test(val);
	// },
	mobile(val) {
		return val && /^(?:\+?86)?1(?:3\d{3}|5[^4\D]\d{2}|8\d{3}|7(?:[35678]\d{2}|4(?:0\d|1[0-2]|9\d))|9[01356789]\d{2}|66\d{2})\d{6}$/.test(val);
	},
	fifteen(val) {
		return val && /^[\d\-_\+]{2,15}$/.test(val);
	},
	email(val) {
		return val && /^[a-zA-Z0-9_\-\.]+@[a-zA-Z0-9_-]+(\.[a-zA-Z0-9_-]+)+$/.test(val);
	},
	password(val) {
		return val && val.length && val.length > 5 && !/^\d+$/.test(val);
	},
	bank(val) {
		if (!val) return false;
		val = String(val);
		var lastNum=val.substr(val.length-1,1);     //取出最后一位（与luhm进行比较）
		var first15Num=val.substr(0,val.length-1);  //前15或18位
		var newArr=[];
		for(var i=first15Num.length-1;i>-1;i--){    //前15或18位倒序存进数组
			newArr.push(first15Num.substr(i,1));
		}
		var arrJiShu=[];  //奇数位*2的积 <9
		var arrJiShu2=[]; //奇数位*2的积 >9

		var arrOuShu=[];  //偶数位数组
		for(var j=0;j<newArr.length;j++){
			if((j+1)%2==1){//奇数位
				if(parseInt(newArr[j])*2<9) {
					arrJiShu.push(parseInt(newArr[j])*2);
				} else {
					arrJiShu2.push(parseInt(newArr[j])*2);
				}
			} else {
				//偶数位
				arrOuShu.push(newArr[j]);
			}
		}

		var jishu_child1=[];//奇数位*2 >9 的分割之后的数组个位数
		var jishu_child2=[];//奇数位*2 >9 的分割之后的数组十位数
		for(var h=0;h<arrJiShu2.length;h++){
			jishu_child1.push(parseInt(arrJiShu2[h])%10);
			jishu_child2.push(parseInt(arrJiShu2[h])/10);
		}

		var sumJiShu=0; //奇数位*2 < 9 的数组之和
		var sumOuShu=0; //偶数位数组之和
		var sumJiShuChild1=0; //奇数位*2 >9 的分割之后的数组个位数之和
		var sumJiShuChild2=0; //奇数位*2 >9 的分割之后的数组十位数之和
		var sumTotal;
		for(var m=0;m<arrJiShu.length;m++){
			sumJiShu=sumJiShu+parseInt(arrJiShu[m]);
		}

		for(var n=0;n<arrOuShu.length;n++){
			sumOuShu=sumOuShu+parseInt(arrOuShu[n]);
		}

		for(var p=0;p<jishu_child1.length;p++){
			sumJiShuChild1=sumJiShuChild1+parseInt(jishu_child1[p]);
			sumJiShuChild2=sumJiShuChild2+parseInt(jishu_child2[p]);
		}
		//计算总和
		sumTotal=parseInt(sumJiShu)+parseInt(sumOuShu)+parseInt(sumJiShuChild1)+parseInt(sumJiShuChild2);

		//计算Luhm值
		var k= parseInt(sumTotal)%10==0?10:parseInt(sumTotal)%10;
		var luhm= 10-k;

		return lastNum == luhm;
	}
};
/*获取当前页带参数的url*/
function getCurrentPageUrlWithArgs(){
	var pages = getCurrentPages()    //获取加载的页面
	var currentPage = pages[pages.length-1]    //获取当前页面的对象
	var url = currentPage.route    //当前页面url
	var options = currentPage.options    //如果要获取url中所带的参数可以查看options

	//拼接url的参数
	var urlWithArgs = url + '?'
	for(var key in options){
		var value = options[key]
		urlWithArgs += key + '=' + value + '&'
	}
	urlWithArgs = urlWithArgs.substring(0, urlWithArgs.length-1)

	return encodeURIComponent(urlWithArgs)
};
// 时间戳
const timeMap={
    y: 31536000000,
    m: 2592000000,
    d: 86400000,
    h: 3600000,
    n: 60000,
    s: 1000
};
//缓存模块  时间可以是1y 1m 1d.. 还有毫秒数
export const cookieStorage={
	set:function(key,value,time){
		let data={};
		data.data=value;
        let timestamp="";
        time+="";
		// 缓存时间设置
		if(time){
			var last=time.charAt(time.length-1);
			if(!is.isNum(last)){
				timestamp=(time.slice(0,time.length-1))*(timeMap[last])+new Date().getTime();
			}
			else {
				timestamp=time*1+new Date().getTime();
			}
		}
		else{
			timestamp=null;
		}
		data.expire=timestamp;
			wx.setStorageSync(key,data);
	},
	get:function(key){
		if(!wx.getStorageSync(key)){
			return null;
		}
		let data=wx.getStorageSync(key),
		expireTime=data.expire;
		if(expireTime){
			if(expireTime>new Date().getTime()){
				return data.data;
			}else{
				this.clear(key);
				return null;
			}
		} else {
			return data.data;
		}
	},
	clear:function(key){
		wx.removeStorageSync(key);
	},
	clearAll: function() {
		wx.clearStorageSync()
	}
};
// 页面登陆
function pageLogin(url,callback){
    var token=cookieStorage.get('user_token');
    if(!token){
			wx.redirectTo({
				url: '/pages/user/register/register?url=' + url
			})
    } else {
    	callback && callback(token);
    }
}

// 页面登录
function modelPageLogin(url, callback) {
	var token=cookieStorage.get('user_token');
	if(!token){
		wx.showModal({
			title: '提示',
			content: '您还未登录,是否前往登录?',
			showCancel: true,
			cancelText: '否',
			confirmText: '是',
			success (res) {
				if (res.confirm) {
					wx.redirectTo({
						url: '/pages/user/register/register?url=' + url
					})
				}
			}
		})
	} else {
		callback && callback(token);
	}
}

function dateFormat(timestamp, fmt) {
	let date = new Date(timestamp.replace(/-/g,'/'))
	var o = {   
    "M+" : date.getMonth()+1,                 //月份   
    "d+" : date.getDate(),                    //日   
    "h+" : date.getHours(),                   //小时   
    "m+" : date.getMinutes(),                 //分   
    "s+" : date.getSeconds(),                 //秒   
    "q+" : Math.floor((date.getMonth()+3)/3), //季度   
    "S"  : date.getMilliseconds()             //毫秒   
  };   
  if(/(y+)/.test(fmt))   
    fmt=fmt.replace(RegExp.$1, (date.getFullYear()+"").substr(4 - RegExp.$1.length));   
  for(var k in o)   
    if(new RegExp("("+ k +")").test(fmt))   
  fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));   
  return fmt;   
}

function formatRichText(html){
  let newContent= html.replace(/<img[^>]*>/gi,function(match,capture){
    match = match.replace(/style="[^"]+"/gi, '').replace(/style='[^']+'/gi, '');
    match = match.replace(/width="[^"]+"/gi, '').replace(/width='[^']+'/gi, '');
    match = match.replace(/height="[^"]+"/gi, '').replace(/height='[^']+'/gi, '');
    return match;
  });
  newContent = newContent.replace(/style="[^"]+"/gi,function(match,capture){
    match = match.replace(/width:[^;]+;/gi, 'max-width:100%;').replace(/width:[^;]+;/gi, 'max-width:100%;');
    return match;
  });
  newContent = newContent.replace(/<br[^>]*\/>/gi, '');
  newContent = newContent.replace(/\<img/gi, '<img style="max-width:100%;height:auto;display:block;margin-top:0;margin-bottom:0;"');
  return newContent;
}

// 确认获取位置授权
function locationAuth(callback) {
	wx.getSetting({
		success(res) {
			if(res.authSetting['scope.userLocation'] != undefined && res.authSetting['scope.userLocation'] != true) {
				wx.showModal({
					title: '请求授权当前位置',
					content: '需要获取您的地理位置，请确认授权',
					success: function (res) {
						if (res.confirm) {
							wx.openSetting({
								success: function (dataAu) {
									if (dataAu.authSetting["scope.userLocation"] == true) {
										wx.showToast({
											title: '授权成功',
											icon: 'success',
											duration: 1000
										})
										callback && callback()
									} else {
										wx.showToast({
											title: '授权失败',
											icon: 'none',
											duration: 1000
										})
									}
								}
							})
						}
					}
				})
			} else if (res.authSetting['scope.userLocation'] == undefined) {
				callback && callback()
			} else {
				callback && callback()
			}
		}
	})
}

// 获取经纬度
function getLocation(callback) {
	locationAuth(
		wx.getLocation({
			type: 'wgs84',
			success (res) {
				cookieStorage.set('latitude', res.latitude)
				cookieStorage.set('longitude', res.longitude)
				callback && callback(res.latitude, res.longitude)
			},
			fail () {
				wx.showToast({
					title: '获取用户位置失败',
					icon: 'none'
				})
			}
		})
	)
}

// 打电话
function callMobile(mobile) {
	wx.makePhoneCall({
		phoneNumber: String(mobile),
		success(res) {
			
		},
		fail(e) {
			
		}
	})
}

// 获取用户信息作为分享
function setShareLink(url) {
	url = url ? url : getUrl()
	url = decodeURIComponent(url)
	let userInfo = cookieStorage.get('userInfo')
	if(userInfo) {
		if(url.indexOf('?') !== -1) {
			return `${url}&shareId=${userInfo.id}`
		} else {
			return `${url}?shareId=${userInfo.id}`
		}
	} else {
		return `${url}`
	}
}

// 转换分钟显示时间
function changeTime(number) {
	let hour = Math.floor(number / 60 / 60)
	let minutes = Math.floor((number - hour * 60 * 60) / 60)
	let second = Math.floor(number - hour * 60 * 60 - minutes * 60)
	if(hour > 0) {
		hour = hour > 10 ? hour : '0'+hour
		return `${hour}:${minutes}:${second}`
	} else {
		if(minutes > 0) {
			minutes = minutes > 10 ? minutes : '0'+minutes
			return `${minutes}:${second}`
		} else {
			second = second > 10 ? second : '0'+second
			return `00:${second}`
		}
	}
}

module.exports = {
	getUrl: getCurrentPageUrlWithArgs,
	pageLogin:pageLogin,
	is:is,
	cookieStorage:cookieStorage,
	format: dateFormat,
	richtext: formatRichText,
	modelLogin: modelPageLogin,
	locationAuth: locationAuth,
	getLocation: getLocation,
	callMobile: callMobile,
	setShareLink: setShareLink,
	changeTime: changeTime
}