import {
  config,
  is,
  pageLogin,
  getUrl,
  sandBox,
  cookieStorage
} from "../../../es6/myapp.js";
Page({
  data: {
    show: false,
    rule: "",
    list: [],
    prices: [],
    current_page: 1,
    total_pages: 2,
    message: '活动规则',
    showCtrol: false
  },
  bindgetuserinfo(e) {
    // 说明用户同意授权
    if (e.detail.userInfo) {
      this.updateUserInfo(e.detail.userInfo)
    }
  },
  // 更新用户信息
  updateUserInfo(e) {
    sandBox.post({
      api: 'api/users/update/info',
      header: {
        Authorization: cookieStorage.get('user_token')
      },

      data: {
        nick_name: e.nickName,
        sex: e.gender == 1 ? '男' : '女',
        avatar: e.avatarUrl,
      },
    }).then(res => {
      if (res.statusCode == 200) {
        res = res.data;
        if (res.status) {
          // this.bargain()
        } else {
          wx.showModal({
            content: res.message || "更新失败",
            showCancel: false
          });
        }
        wx.hideLoading();
      }
      else {
        wx.showModal({
          content: "更新失败",
          showCancel: false
        });
        wx.hideLoading();
      }
    })
  },
  getUserInfo() {
    sandBox.get({
      api: 'api/me',
      header: {
        Authorization: cookieStorage.get('user_token')
      },
    }).then(res => {
      if (res.data.data.status) {
        // 是否显示授权按钮
        // let agent = res.data.data.is_agent;
        if (!res.data.data.avatar) {
          this.setData({
            showCtrol: true
          })
        }
        cookieStorage.set('userInfoImg', res.data.data.avatar)
        cookieStorage.set('userInfoName', res.data.data.nick_name)
      }
    })
  },
  showRule() {
    this.setData({
      show: true
    });
  },
  closeRule() {
    this.setData({
      show: false
    });
  },
  //发起砍价
  bargain(e) {
    let that = this;
    var token = cookieStorage.get("user_token");
    var id = e.currentTarget.dataset.id;
    var goods_id = e.currentTarget.dataset.goods_id;
    var data = {
      reduce_id: id
    };
    that.setData({
      id: id
    });
    if (token) {
      sandBox
        .post({
          api: `api/reduce`,
          header: {
            Authorization: token
          },
          data: data
        })
        .then(res => {
          if (res.statusCode == 200) {
            res = res.data;
            if (res.status) {
              that.setData({
                reduce_items_id: res.data.reduce_items_id
              });
              that.listgetMessage();
            }
          } else {
          }
        });
    } else {
      let url = "pages/bargain/index/index";
      wx.showModal({
        content: "请重新登录",
        duration: 1500,
        showCancel: false,
        success: res => {
          if (res.confirm) {
            wx.navigateTo({
              url: `/pages/user/register/register?url=${url}`
            });
            return;
          }
        },
        cancel: () => {
          wx.navigateTo({
            url: `/pages/user/register/register?url=${url}`
          });
          return;
        }
      });
    }
  },
  //获取详情页信息
  listgetMessage() {
    let that = this;
    var token = cookieStorage.get("user_token");
    sandBox
      .get({
        api: `api/reduce/showItem?reduce_items_id=${this.data.reduce_items_id}`,
        header: {
          Authorization: token
        }
      })
      .then(res => {
        if (res.statusCode == 200) {
          res = res.data;
          if (res.status) {
            if (res.data.order != null) {
              if (res.data.order.status == 1) {
                wx.navigateTo({
                  url: `/pages/order/detail/detail?no=${res.data.order.order_no}`
                });
              } else {
                wx.navigateTo({
                  url: `/pages/bargain/details/details?reduce_items_id=${this.data.reduce_items_id}&id=${this.data.id}`
                });
              }
            } else {
              wx.navigateTo({
                url: `/pages/bargain/details/details?reduce_items_id=${this.data.reduce_items_id}&id=${this.data.id}`
              });
            }
          }
        } else {
          wx.showToast({
            title: res.data.data.message,
            icon: none,
            duration: 2000
          });
        }
      });
  },
  onLoad: function (options) {
    var token = cookieStorage.get("user_token");
    var windowHeight = wx.getSystemInfoSync().windowHeight; //获取设备的高度
    this.setData({
      Height: windowHeight
    });
    this.getMessage();
  },
  onShow: function () {
    this.getRule();
    var token = cookieStorage.get("user_token");
    if (token) {
      this.getUserInfo()
    }
  },
  onPullDownRefresh: function () {
    this.getMessage();
  },
  getRule() {
    sandBox
      .get({
        api: "api/reduce/help/text"
      })
      .then(res => {
        if (res.statusCode == 200) {
          res = res.data;
          if (res.status) {
            this.setData({
              rule: res.data.reduce_help_text
            });
          }
        }
      });
  },
  getMessage() {
    let that = this;
    sandBox
      .get({
        api: "api/reduce/list",
        data: {
          page: this.data.current_page
        }
      })
      .then(res => {
        if (res.statusCode == 200) {
          res = res.data;
          if (res.status) {
            if (this.data.current_page < this.data.total_pages) {
              this.data.current_page = res.meta.pagination.current_page;
              that.setData({
                [`list[${this.data.current_page - 1}]`]: res.data,
                current_page: this.data.current_page,
                total_pages: res.meta.pagination.total_pages
              });
            } else {
              wx.showToast({
                title: "再拉也没有了",
                icon: "none",
                duration: 2000
              });
            }
          }
        }
      });
  },
  onReachBottom() {
    if (this.data.current_page < this.data.total_pages) {
      this.data.current_page++;
      this.getMessage();
    } else {
      wx.showToast({
        title: "再拉也没有了",
        icon: "none",
        duration: 2000
      });
    }
  }
});
