import { sandBox, cookieStorage, getUrl } from '../../../es6/myapp.js';

Page({
  data: {
    categoryList: [],
    categoryActive: 0,
    cateActive: 0,
    videoList: []
  },
  // 跳转到视频详情
  jumpInfo(e){
    const token = cookieStorage.get("user_token")
    if(!token) {
      wx.showModal({
        title: '提示',
        content: '您还未登录,是否前往登录?',
        showCancel: true,
        cancelText: '否',
        confirmText: '是',
        success (res) {
          if (res.confirm) {
            var url = getUrl();
            wx.redirectTo({
              url: `/pages/user/register/register?url=${url}`
            })
          }
        },
        complete() {
          return false
        }
      })
    } else {
      var id=e.currentTarget.dataset.id;
      wx.navigateTo({
          url: '/pages/index/videoinfo/videoinfo?id='+id
      })
    }
  },
  onLoad() {
    this.getCategory()
  },
  // 获取顶级分类
  getCategory() {
    wx.showLoading({
      title: '加载中'
    })
    sandBox.get({
      api: 'api/course/category'
    }).then(res => {
      wx.hideLoading()
      res = res.data;
      if(res.status) {
        this.setData({
          categoryList: res.data
        })
        this.getCategoryVideo(res.data[0].children[0].id)
      } else {
        wx.showToast({
          title: res.message || "获取分类失败",
          image: "../../../assets/image/error1.png"
        });
      }
    }).catch(e => {
      wx.hideLoading()
      wx.showToast({
        title: e.message || "获取分类失败",
        image: "../../../assets/image/error1.png"
      });
    })
  },
  // 选择顶级分类下标
  changeCategoryActive(e) {
    let index = e.currentTarget.dataset.index
    this.setData({
      categoryActive: index,
      cateActive: 0,   // 切换顶级分类时重置下标志位0
      videoList: []   // 重置视频列表为空数组
    })
    // 请求视频
    this.getCategoryVideo(this.data.categoryList[0].children[0].id)
  },
  // 点击分类获取课程
  tapGetVideo(e) {
    let index = e.currentTarget.dataset.index
    this.setData({
      cateActive: index
    })
    let id = e.currentTarget.dataset.id
    this.getCategoryVideo(id)
  },
  // 获取分类课程
  getCategoryVideo(id) {
    wx.showLoading({
        title: '加载中'
      })
    sandBox.get({
      api: "api/course/course",
      data:{
        category: id
      }
    }).then(res => {
      wx.hideLoading()
      res = res.data
      if(res.status) {
        this.setData({
          videoList: res.data
        })
      } else {
        wx.showToast({
          title: res.message || "获取视频失败",
          image: "../../../assets/image/error1.png"
        });
      }
    }).catch(e => {
      wx.hideLoading()
      wx.showToast({
        title: e.message || "获取视频失败",
        image: "../../../assets/image/error1.png"
      });
    })
  }
})