import {config,pageLogin,getUrl,sandBox,cookieStorage} from '../../../es6/myapp.js'
Page({
	data: {
		activeIndex: 0,
		sliderOffset: 0,
		width: 0,
        animationData:{},
		tabList: [
			{
				title: '线上',
				init: false,
				page: 0,
				more: true
			},
			{
				title: '线下',
				init: false,
				page: 0,
				more: true
			}
		],
		dataList: {
			0: [],
			1: []
		},
		is_coupon: 1, // 用于判断是否为优惠券 1：优惠券 0：促销折扣
		config: ''
	},
	onLoad(e) {
        // 第三方平台配置颜色
        var gbConfig = cookieStorage.get('globalConfig') || '';
        this.setData({
            config: gbConfig
        })
		if (e.type) {
			this.setData({
				activeIndex: e.type
			})
		};
		if (e.is_coupon) {
			if (e.is_coupon != 1) {
				wx.setNavigationBarTitle({
					title: '促销折扣中心'
				})
			} else {
				wx.setNavigationBarTitle({
					title: '领券中心'
				})
			}
			this.setData({
				is_coupon: e.is_coupon
			})
		} else {
			var referrerInfo = cookieStorage.get('referrerInfo');
			if (referrerInfo && referrerInfo.extraData && referrerInfo.extraData.is_coupon == 0){
                wx.setNavigationBarTitle({
                    title: '促销折扣中心'
                })
                this.setData({
                    is_coupon: 0
                })
			} else {
                wx.setNavigationBarTitle({
                    title: '领券中心'
                })
			}
		}
		this.queryCouponList();
	},
	onShow(e) {
        var animation = wx.createAnimation({
            duration: 1000,
            timingFunction: 'ease',
        })

        this.animation = animation

        animation.rotate(-30).step()

        this.setData({
            animationData:animation.export()
        })
		wx.getSystemInfo({
			success: res => {
				this.setData({
					width: res.windowWidth / this.data.tabList.length,
					sliderOffset: res.windowWidth / this.data.tabList.length * this.data.activeIndex
				})
			}
		});
	},
	tabClick(e) {
		var status = e.currentTarget.id;
		this.setData({
			sliderOffset: e.currentTarget.offsetLeft,
			activeIndex: status
		});
		if (!this.data.tabList[status].init) {
			this.queryCouponList(status);
		}
	},
	onReachBottom(e) {
		var status = this.data.activeIndex
		var page = this.data.tabList[status].page + 1;
		var tabList = `tabList[${status}]`;
		if (this.data.tabList[status].more) {
			this.queryCouponList(status,page);
		} else {
			wx.showToast({
				image: '../../../assets/image/error.png',
				title: '再拉也没有啦'
			});
		}
	},
    jumpHome() {
		wx.switchTab({
			url: '/pages/index/index/index'
		})
	},
	// 跳转详情
	jumpDetailOn(e) {
		var id = e.currentTarget.dataset.id;
        var limit = e.currentTarget.dataset.limit;
        if (limit == 0) {
        	return
		}
		wx.navigateTo({
			url: '/pages/coupon/onDetail/onDetail?id=' + id + '&is_coupon=' + this.data.is_coupon
		})
	},
	jumpDetail(e) {
		var id = e.currentTarget.dataset.id;
        var limit = e.currentTarget.dataset.limit;
        if (limit == 0) {
            return
        }
		wx.navigateTo({
		  url: '/pages/coupon/offDetail/offDetail?id=' + id + '&is_coupon=' + this.data.is_coupon
		})
	},
	jumpList(e) {
		var id = e.currentTarget.dataset.id;
		wx.navigateTo({
			url: '/pages/coupon/goods/goods?id=' + id
		})

	},
	// 请求优惠券列表
	queryCouponList(type = 0, page = 1) {

		wx.showLoading({
			title: "加载中",
			mask: true
		});

		var token = cookieStorage.get('user_token') || '';
		sandBox.get({
			api: 'api/discount/list',
			header: {
				Authorization: token
			},
			data: {
				page,
				type,
				is_coupon: this.data.is_coupon
			}
		}).then(res => {
			if (res.statusCode == 200) {
				res = res.data;

				if (res.status) {
					var pages = res.meta.pagination;
					var current_page = pages.current_page;
					var total_pages = pages.total_pages;
					var tabList = `tabList[${type}]`;
					this.setData({
						[`dataList.${type}[${page - 1}]`] : res.data,
						[`${tabList}.init`]: true,
						[`${tabList}.page`]: current_page,
						[`${tabList}.more`]: current_page < total_pages,
					})
				} else {
					wx.showModal({
						content: res.message || '请求失败',
						showCancel: false
					})
				}
			} else {
				wx.showModal({
					content: res.message || '请求失败',
					showCancel: false
				})
			}
			wx.hideLoading()
		}).catch(rej => {
			wx.hideLoading()
			wx.showModal({
				content: res.message || '请求失败',
				showCancel: false
			})
		})

	},
	// 领取优惠券
	getCoupon(e) {
		var token = cookieStorage.get('user_token');
		var code = e.currentTarget.dataset.code;
		var index = e.currentTarget.dataset.index;
		var findex = e.currentTarget.dataset.findex;
		if (token) {
			this.convertCoupon(code, findex, index);
		} else {
			wx.showModal({
				content: '请先登录',
				showCancel: false,
				success: res => {
					if (res.confirm || (!res.cancel && !res.confirm)) {
                        pageLogin(getUrl());
					}
				}
			})
		}
	},
	// 领取优惠券接口
	convertCoupon(code, findex, index) {
		var token = cookieStorage.get('user_token');
		var activeIndex = this.data.activeIndex;
		var list = `dataList[${activeIndex}]`;
		wx.showLoading({
			title: "正在领取",
			mask: true
		});
		sandBox.post({
			api: 'api/coupon/convert',
			header: {
				Authorization: token
			},
			data: {
				coupon_code:code
			}
		}).then(res => {
			wx.hideLoading();
			if (res.statusCode == 200) {
				res = res.data;
				if (res.status) {
					var list = `dataList.${activeIndex}`;
					this.setData({
						[`${list}[${index}][${findex}].has_get`]: true
					})
					wx.showToast({
						title: '领取成功',
					});
				} else {
					wx.showToast({
						title: res.message || '领取失败',
						image: '../../../assets/image/error.png'
					})
				}
			} else {
				wx.showToast({
					title: '领取失败',
					image: '../../../assets/image/error.png'
				})
			}

		}).catch(rej => {
			wx.showToast({
				title: '领取失败',
				image: '../../../assets/image/error.png'
			})
			wx.hideLoading();
		})
	}
})