import {config,sandBox,pageLogin,getUrl,cookieStorage} from '../../../es6/myapp.js';

Page({
	data: {
		detail: '',
		barcode: '',
		is_coupon: 1, // 用于判断是否为优惠券 1：优惠券 0：促销折扣
		init: false,
        agent_code: '',
		config: ''
	},
	onLoad(e) {
        // 第三方平台配置颜色
        var gbConfig = cookieStorage.get('globalConfig') || '';
        this.setData({
            config: gbConfig
        })
		var id = e.id;
		var coupon_id = e.coupon_id;
        var agent_code = e.agent_code||  '';
        var is_coupon = e.is_coupon || '';
        const timeMap = {
            y: 31536000000,
            m: 2592000000,
            d: 86400000,
            h: 3600000,
            n: 60000,
            s: 1000
        };
        // 默认有效期为7天
        var valid_time = "";
        if (e.scene) {
            var scene = decodeURIComponent(e.scene);
            var sceneArr = scene.split('_');
            if (sceneArr.length > 0) {
                id = sceneArr[0]
                agent_code = sceneArr[1]
                is_coupon = 1
            }
        }
        if (!cookieStorage.get('distribution_valid_time')) {
            valid_time = 10080;
        } else {
            valid_time = cookieStorage.get('distribution_valid_time');
        }
        let timeStamp = new Date().getTime();
        timeStamp += timeMap.n * valid_time;
        if (agent_code) {
            cookieStorage.set('coupon_agent_code', agent_code, valid_time + 'n');
        }
        this.setData({
            agent_code: agent_code
        })

		this.queryCouponDetail(id, coupon_id);
		if (is_coupon) {
			if (is_coupon != 1) {
				wx.setNavigationBarTitle({
					title: '线下折扣券详情'
				})
			} else {
				wx.setNavigationBarTitle({
					title: '线下优惠券详情'
				})
			}
			this.setData({
				is_coupon: is_coupon
			})
		} else {
			wx.setNavigationBarTitle({
				title: '线下优惠券详情'
			})
		}
	},
	onShow(){
       /* let app =getApp();
        app.isBirthday().then(()=>{
            if(cookieStorage.get("birthday_gift")){
                var giftData=cookieStorage.get("birthday_gift").data;
                new app.ToastPannel().__page.showText(giftData);
            }
        });*/
    },
	jumpList(e) {
		wx.navigateTo({
			url: '/pages/coupon/goods/goods?id=' + this.data.detail.coupon_id
		})

	},
    jumpHome() {
        wx.switchTab({
            url: '/pages/index/index/index'
        })
    },
	getCoupon() {
		var token = cookieStorage.get('user_token');
		if (token) {
			this.convertCoupon(this.data.detail.code);
		} else {
			wx.showModal({
				content: '请先登录',
				showCancel: false,
                success: res => {
                    if (res.confirm || (!res.cancel && !res.confirm)) {
                        pageLogin(getUrl());
                    }
                }
			})
		}
	},
	// 领取优惠券接口
	convertCoupon(code) {
		var token = cookieStorage.get('user_token');
		wx.showLoading({
			title: "正在领取",
			mask: true
		});
		sandBox.post({
			api: 'api/coupon/convert',
			header: {
				Authorization: token
			},
			data: {
				coupon_code:code,
                agent_code: this.data.agent_code
			}
		}).then(res => {
			wx.hideLoading();
			if (res.statusCode == 200) {
				res = res.data;
				if (res.status) {
					this.setData({
						'detail.has_get': true
					})
					wx.showToast({
						title: '领取成功',
					});
				} else {
					wx.showToast({
						title: res.message || '领取失败',
						image: '../../../assets/image/error.png'
					})
				}
			} else {
				wx.showToast({
					title: '领取失败',
					image: '../../../assets/image/error.png'
				})
			}
		}).catch(rej => {
			wx.showToast({
				title: '领取失败',
				image: '../../../assets/image/error.png'
			})
			wx.hideLoading();
		})

	},
	// 查询优惠券详情
	queryCouponDetail(id,coupon_id) {
		wx.showLoading({
			title: "加载中",
			mask: true
		});
		var coupon_ids = coupon_id ? coupon_id : ''

		var token = cookieStorage.get('user_token');
		sandBox.get({
			api: 'api/discount/' + id + '/detail',
			header: {
				Authorization: token
			},
			data: {
                coupon_id: coupon_ids
			}

		}).then(res =>{
			if (res.statusCode == 200) {
				res = res.data;
				if (res.status) {
					this.setData({
						detail: res.data,
						init: true
					})
				} else {
					wx.showModal({
						content: res.message || '请求失败',
						showCancel: false
					})
				}
			} else {
				wx.showModal({
					content: "请求失败",
					showCancel: false
				})
			}
			wx.hideLoading()
		}).catch(rej => {
			wx.hideLoading()
			wx.showModal({
				content: '请求失败',
				showCancel: false
			})
		})
	}
})