import {format, sandBox, setShareLink} from '../../../es6/myapp.js';

Page({
  data: {
    currentPage: 1,
    activityList: [],
    activityPage: {}
  },
  onLoad() {
    this.getActivityList()
  },
  // 跳转到活动详情
  jumpActivityInfo(e){
    var id=e.currentTarget.dataset.id;
    wx.navigateTo({
        url: '/pages/index/activityinfo/activityinfo?id='+id
    })
  },
  // 获取活动列表
  getActivityList() {
    wx.showLoading({
        title: '加载中'
      })
    sandBox.get({
      api: "api/course/activities"
    }).then(res => {
      wx.hideLoading()
      res = res.data
      if (res.status) {
        if(res.data && res.data.length > 0) {
          res.data.map(item => {
            item.end_time = format(item.end_time, 'yyyy-MM-dd')
            item.start_time = format(item.start_time, 'yyyy-MM-dd')
            item.type_name = this.activityType(item.type)
          })
        }
        this.setData({
          activityList: (res.data && res.data.length > 0) ? this.data.activityList.concat(res.data) : this.data.activityList,
          activityPage: res.meta.pagination
        })
      } else {
        wx.showToast({
          title: "获取店铺详情失败",
          icon: 'none'
        });
      }
    }).catch(e => {
      wx.hideLoading()
      wx.showToast({
        title: "获取活动列表失败",
        icon: 'none'
      });
    })
  },
  // 活动类型
  activityType(type) {
    let out
    switch(type) {
      case 1:
      case '1':
        out = '报名未开始'
        break;
      case 2:
      case '2':
        out = '正在报名中'
        break;
      case 3:
      case '3':
        out = '报名已结束'
        break;
      default:
        out = '活动进行中'
    }
    return out
  },
  // 上拉加载
  onReachBottom() {
    if (this.data.currentPage >= this.data.activityPage.total_pages) {
      return false
    }
    // 页数++
    this.data.currentPage ++;
    this.setData({
      currentPage: this.data.currentPage
    })
    this.getActivityList()
  },
  // 分享
  onShareAppMessage(res) {
    let title, imgUrl
    if(res.from === 'button') {
      let info = res.target.dataset.info
      imgUrl = info.img
      title = `这个活动这个火热->${info.name}<-,你还不来参加吗?`
    }
    return {
      title: title,
      path: setShareLink,
      imageUrl: imgUrl
    }
  }
})