import {config,getUrl,pageLogin,sandBox,cookieStorage} from '../../../es6/myapp.js';

Page({
  data: {
    courseList: [],
    navList: ['精彩视频专区', '热门课程专区', '推荐课程专区'],
    activeIndex: 0,
    currentPage: 1,
    coursePage: {}
  },
  onLoad() {
    this.getVideoList({
      isWonderful: 1,
      page: this.data.currentPage
    })
  },
  // 切换nav
  changeNav(e) {
    // 重置参数
    this.setData({
      courseList: [],
      currentPage: 1,
      coursePage: {}
    })
    let index = e.currentTarget.dataset.index
    this.setData({
      activeIndex: index
    })
    this.checkNavVideo()
  },
  // 判断导航获取视频
  checkNavVideo() {
    switch(this.data.activeIndex) {
      case 0:
      case '0':
        this.getVideoList({
          isWonderful: 1,
          page: this.data.currentPage
        })
        break;
      case '1':
      case 1:
        this.getVideoList({
          isHot: 1,
          page: this.data.currentPage
        })
        break
      default:
        this.getVideoList({
          isRecom: 1,
          page: this.data.currentPage
        })
    } 
  },
  // 获取视频详情
  getVideoList(data) {
    wx.showLoading({
        title: '加载中'
      })
    sandBox.get({
      api: 'api/course/course',
      data
    }).then(res => {
      wx.hideLoading()
      res = res.data
      if(res.status) {
        this.setData({
          courseList: (res.data && res.data.length > 0) ? this.data.courseList.concat(res.data) : this.data.courseList,
          coursePage: res.meta.pagination
        })
      } else {
        wx.showToast({
          title: `获取${this.data.navList[activeIndex]}失败`,
          icon: 'none'
        })
      }
    }).catch(e => {
      wx.hideLoading()
      wx.showToast({
        title: `获取${this.data.navList[activeIndex]}失败`,
        icon: 'none'
      })
    })
  },
  // 查看视频
  jumpVideoInfo(e){
    const token = cookieStorage.get('user_token')
    if(!token) {
      wx.showModal({
        title: '提示',
        content: '您还未登录,是否前往登录?',
        showCancel: true,
        cancelText: '否',
        confirmText: '是',
        success (res) {
          if (res.confirm) {
            var url = getUrl();
            wx.redirectTo({
              url: `/pages/user/register/register?url=${url}`
            })
          }
        },
        complete() {
          return false
        }
      })
    } else {
      var id=e.currentTarget.dataset.id;
      wx.navigateTo({
        url: '/pages/index/videoinfo/videoinfo?id='+id
      })
    }
  },
  // 上拉加载
  onReachBottom() {
    if (this.data.currentPage >= this.data.coursePage.total_pages) {
      return false
    }
    // 页数++
    this.data.currentPage ++;
    this.setData({
      currentPage: this.data.currentPage
    })
    this.checkNavVideo()
  }
})