import { sandBox, config, getUrl, modelLogin, setShareLink, getLocation } from '../../../es6/myapp.js';
// 腾讯位置jssdk
var QQMapWX = require('../../../utils/qqmap-wx-jssdk.min.js');
var qqmapsdk;

Page({
  data: {
    bannerList: [],
    videoList: [],
    videoPage: {},
    currentPage: 1,
    baseUrl: config.GLOBAL.baseUrl,
    latitude: '',
    longitude: '',
    city: '北京市'
  },
  onLoad() {
    qqmapsdk = new QQMapWX({
      key: 'SEOBZ-DDTWU-75FVI-2F4HR-N6KQK-XEBOW'
    })
    this.init()
  },
  onShow() {
    this.getUserLocation()
  },
  // 初始化
  init () {
    this.getBanner()
    this.getVideo()
  },
  // 跳转
  jumpItem(e) {
    let login = e.currentTarget.dataset.login
    var url = e.currentTarget.dataset.url;
    if(login) {
      modelLogin(url, () => {
        wx.navigateTo({
          url: `/${url}`
        })
      })
    } else {
      wx.navigateTo({
        url: `/${url}`
      })
    }
  },
  // 查看视频
  jumpVideoInfo(e){
    modelLogin(getUrl(), () => {
      var id=e.currentTarget.dataset.id;
      wx.navigateTo({
        url: '/pages/index/videoinfo/videoinfo?id='+id
      })
    })
  },
  // 获取广告
  getBanner() {
    wx.showLoading({
        title: '加载中'
      })
    sandBox.get({
      api: 'api/course/advertising',
      data: {
        site: "banner"
      }
    }).then(res => {
      wx.hideLoading()
      res = res.data
      if (res.code === 200) {
        this.setData({
          bannerList: res.data
        })
      } else {
        wx.showToast({
          title: res.message || "获取广告失败",
          icon: 'none'
        });
      }
    }).catch(e => {
      wx.hideLoading()
      wx.showToast({
        title: "获取广告失败",
        icon: 'none'
      });
    })
  },
  // 获取精彩视频
  getVideo() {
    wx.showLoading({
        title: '加载中'
      })
    sandBox.get({
      api: 'api/course/course',
      data: {
        // isWonderful: 0,
        page: this.data.currentPage
      }
    }).then(res => {
      wx.hideLoading()
      res = res.data
      if (res.status) {
        this.setData({
          videoList: this.data.videoList.concat(res.data),
          videoPage: res.meta.pagination
        })
      } else {
        wx.showToast({
          title: res.message || "获取视频失败",
          icon: 'none'
        });
      }
    }).catch(e => {
      wx.hideLoading()
      wx.showToast({
        title: "获取视频失败",
        icon: 'none'
      });
    })
  },
  // 上拉加载
  onReachBottom() {
    if (this.data.currentPage >= this.data.videoPage.total_pages) {
      return false
    }
    // 页数++
    this.data.currentPage ++;
    this.setData({
      currentPage: this.data.currentPage
    })
    this.getVideo()
  },
  // 广告点击效果
  tapBanner(e) {
    let data = e.currentTarget.dataset.banner;
    switch (data.click) {
      // 打电话
      case "phone":
        wx.makePhoneCall({
          phoneNumber: data.link
        })
        break;
      // 小程序内跳转
      case "page":
        if (data.link) {
          var path = [
            'pages/index/index/index',
            'pages/classify/classify/classify',
            'pages/user/user/user'
          ];
          var pathIndex = path.indexOf(data.link);
          if (pathIndex == -1) {
            wx.navigateTo({
                url:"/"+data.link
            })
          } else {
            wx.switchTab({
                url:"/"+data.link
            })
          }
        }
        break;
      // 跳转到h5
      case "url":
        if (data.link) {
          wx.navigateTo({
            url: "/pages/index/h5/h5?link="+data.link
          })
        }
        break;
      // 不操作
      default:
    }
  },
  // 获取用户位置
  getUserLocation() {
    let _this = this
    getLocation(_this.getLocal)
  },
  // 获取城市信息
  getLocal(latitude, longitude) {
    qqmapsdk.reverseGeocoder({
      location: {
        latitude,
        longitude
      },
      success: (res => {
        if (res.status === 0) {
          this.setData({
            city: res.result.address_component.city
          })
        }
      })
    })
  },
  onShareAppMessage(res) {
    return {
      title:'快来加入田知花少儿教育吧',
      path: setShareLink(),
      imageUrl: ''
    }
  } 
})