import {config, getLocation, sandBox} from '../../../es6/myapp.js';

Page({
  data: {
    shopList: [],
    currentPage: 1,
    shopPage: {},
    baseUrl: config.GLOBAL.baseUrl
  },
  onLoad() {
    this.getShopList()
  },
  // 跳转到门店详情
  jumpShopInfo(e){
    var id=e.currentTarget.dataset.id;
    let dis=e.currentTarget.dataset.dis;
    wx.navigateTo({
      url: `/pages/index/shopinfo/shopinfo?id=${id}&dis=${dis}`
    })
  },
  // 获取门店数据
  getShopList() {
    getLocation((lat, lon) => {
      wx.showLoading({
        title: '加载中'
      })
      sandBox.get({
        api: 'api/course/shop/index',
        data: {
          page: this.data.currentPage,
          lon,
          lat
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if(res.status) {
          this.data.shopList = this.data.shopList.concat(res.data)
          this.data.shopList.map(item => {
            item.distance = item.distance ?(item.distance / 1000).toFixed(1) : 0
          })
          this.setData({
            shopList: this.data.shopList,
            shopPage: res.meta.pagination
          })
        } else {
          wx.showToast({
            title: "获取线下门店失败",
            icon: 'none'
          });
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
          title: "获取线下门店失败",
          icon: 'none'
        });
      })
    })
  },
  // 上拉
  onReachBottom() {
    if (this.data.currentPage >= this.data.shopPage.total_pages) {
      return false
    }
    // 页数++
    this.data.currentPage ++;
    this.setData({
      currentPage: this.data.currentPage
    })
    this.getShopList()
  }
})