import {config, sandBox, callMobile, getLocation } from '../../../es6/myapp.js';

Page({
  data: {
    detail: {},
    baseUrl: config.GLOBAL.baseUrl,
    infoToggle: false,
    distance: 0
  },
  onLoad(e) {
    let id = e.id
    let dis = e.dis
    this.setData({
      distance: dis
    })
    if(!id) {
      wx.showModal({
        content: "门店id不存在",
        showCancel: false
      });
      return false
    }
    this.getShopInfo(id)
  },
  // 获取店铺详情
  getShopInfo(id) {
    wx.showLoading({
        title: '加载中'
      })
    sandBox.get({
      api: 'api/course/shop/'+id
    }).then(res => {
      wx.hideLoading()
      res = res.data
      if (res.status) {
        this.setData({
          detail: res.data
        })
      } else {
        wx.showToast({
          title: res.message || "获取店铺详情失败",
          icon: 'none'
        });
      }
    }).catch(e => {
      wx.hideLoading()
      wx.showToast({
        title: "获取店铺详情失败",
        icon: 'none'
      });
    })
  },
  // 复制
  bindCopy(e) {
    let wechat = e.currentTarget.dataset.wechat
    wx.setClipboardData({
      data: wechat,
      success (res) {
        
      }
    })
  },
  // 切换
  toggle() {
    this.setData({
      infoToggle: !this.data.infoToggle
    })
  },
  // 拨打
  bindCall(e) {
    let mobile = e.currentTarget.dataset.mobile
    callMobile(mobile)
  },
  // 导航
  setLine() {
    if(!this.data.detail.coordinates) {
      wx.showToast({
        title: '无法获取店铺位置导航失败',
        icon: 'none'
      })
      return false
    }
    let a = this.data.detail.coordinates.split(',')
    let lon = a[0]
    let lat = a[1]
    getLocation(() => {
      wx.openLocation({
        latitude: Number(lat),
        longitude: Number(lon),
        name: this.data.detail.name,
        address: this.data.detail.address
      })
    })
  }
})