import { sandBox, config, cookieStorage, getUrl, richtext, modelLogin, getLocation, changeTime, setShareLink } from '../../../es6/myapp.js';

var t = getApp();

var timer, timeflag = false, spaceTime = 30, totalTime = 0;

Page({
  data: {
    scrollH: 0,
    statusBarHeight: t.globalData.height,
    videoInfo: {},
    baseUrl: config.GLOBAL.baseUrl,
    token: "",
    activeIndex: 1,
    infoToggle: false,
    classToggle: false,
    teacherToggle: false,
    shopList: [],
    navList: [{
      key: 0,
      value: '课程介绍'
    },{
      key: 1,
      value: '课程目录'
    },{
      key: 2,
      value: '视频相关'
    }],
    isAutoPlay: false,
    playId: '', // 当前播放视频id
    initialTime: 0,
    showInitialTime: 0,
    initialTimeFlag: false,
    historyPlay: false
  },
  // 跳转视频相关-店铺
  jumpShopInfo(e){
    var id=e.currentTarget.dataset.id;
    var dis=e.currentTarget.dataset.dis;
    wx.navigateTo({
        url: `/pages/index/shopinfo/shopinfo?id=${id}&dis=${dis}`
    })
  },
  onLoad(e) {
    wx.hideShareMenu()
    // 初始化token
    this.setData({
      token: cookieStorage.get('user_token')
    })
    // 如果从历史记录过来,播放历史记录视频
    if(e.sectionId) {
      // 获取视频详情
      this.getVideoInfo(e.id, () => {
        this.getPlayVideoInfo(e.sectionId, () => {
          // 获取视频相关店铺
          this.getShop()
          // 如果从历史记录过来,获取历史记录播放的时间
          if(e.time) {
            this.setData({
              initialTime: e.time,
              showInitialTime: changeTime(e.time),
              historyPlay: true
            })

            let _this = this
            setTimeout(() => {
              _this.setData({
                historyPlay: false
              })        
            }, 3000)
          }
        })
      })
    }else {
      this.getVideoInfo(e.id)
      // 获取视频相关店铺
      this.getShop()
    }
  },
  // 获取当前视频详情
  getVideoInfo(id, callback) {
    let _this = this
    modelLogin(getUrl(), (token) => {
      wx.showLoading({
        title: '加载中'
      })
      sandBox.get({
        api: `api/course/course/${id}`,
        header: {
          "authorization": token
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if (res.status) {
          // 替换富文本
          res.data.body = res.data.body ? richtext(res.data.body) : ''
          _this.setData({
            videoInfo: res.data
          })
          // 显示转发
          setTimeout(()=> {
            wx.showShareMenu()
          },100)
          
          callback && callback()
        } else {
          wx.showModal({
            content: "获取视频详情失败",
            showCancel: false
          });
        }
      }).catch((e) => {
        wx.hideLoading()
        wx.showModal({
          content: "获取视频详情失败",
          showCancel: false
        });
      })
    })
  },
  // 点解播放
  clickPlay(e) {
    let id = e.currentTarget.dataset.id
    this.getPlayVideoInfo(id)
  },
  // 播放目录视频详情
  getPlayVideoInfo(id, callback) {
    // 判断是不是会员和视频是不是免费
    let isauth = this.data.videoInfo.is_auth_status
    let isfree = this.data.videoInfo.vip_level
    if (!isauth && isfree!==0) {
      wx.showModal({
        title: '提示信息',
        content: '您还没有开通会员,暂不能观看.是否前往开通会员?',
        cancelText: '否',
        confirmText: '是',
        success(res) {
          if (res.confirm) {
            var url = getUrl();
            wx.redirectTo({
              url: `/pages/user/privilegeopen/privilegeopen?url=${url}`
            })
          } else if (res.cancel) {
            // 取消不操作
          }
        }
      })
      return false
    }
    wx.showLoading({
        title: '加载中'
      })
    sandBox.get({
      api: `api/course/course/section/${id}`,
      header: {
        authorization: this.data.token
      }
    }).then(res => {
      wx.hideLoading()
      res = res.data
      if (res.status) {
        // 原来点击目录时更改掉所有 包括 id, name, resource
        // Object.keys(res.data).map(item => {
        //   this.data.videoInfo[item] = res.data[item]
        // })

        // 只修改resource和name
        this.data.videoInfo.resource = res.data.resource
        this.data.videoInfo.name = res.data.name

        this.setData({
          videoInfo: this.data.videoInfo,
          isAutoPlay: true,
          playId: res.data.id
        })

        timeflag = true

        callback && callback()
      } else {
        wx.showModal({
          content: "获取视频详情失败",
          showCancel: false
        });
      }
    }).catch((e) => {
      wx.hideLoading()
      wx.showModal({
        content: "获取视频详情失败",
        showCancel: false
      });
    })
  },
  // 点赞
  giveGood() {
    modelLogin(getUrl(), (token) => {
      wx.showLoading({
        title: '加载中'
      })
      sandBox.post({
        api: `api/course/giveGood`,
        data: {
          type: 'course',
          id: this.data.videoInfo.id
        },
        header: {
          "authorization": token
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if (res.code === 200) {
          wx.showToast({
            title: "点赞成功",
            icon:"success"
          });
          // 更改点赞状态
          this.data.videoInfo.is_good_status = true
          this.setData({
            videoInfo: this.data.videoInfo
          })
          // 成功时点赞数加1
          this.data.videoInfo.good ++
          this.setData({
            videoInfo: this.data.videoInfo
          })
        } else {
          wx.showToast({
            title: res.message || "点赞失败",
            icon: 'none'
          });
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
          title: "点赞失败",
          icon: 'none'
        });
      })
    })
  },
  // 取消点赞
  cancelGood() {
    modelLogin(getUrl(), (token) => {
      wx.showLoading({
        title: '加载中'
      })
      sandBox.post({
        api: `api/course/cancelGood`,
        data: {
          type: 'course',
          id: this.data.videoInfo.id
        },
        header: {
          "authorization": token
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if (res.code === 200) {
          wx.showToast({
            title: "取消点赞成功",
            icon:"success"
          });
          // 更改点赞状态
          this.data.videoInfo.is_good_status = false
          this.setData({
            videoInfo: this.data.videoInfo
          })
          // 成功时点赞数减1
          if(this.data.videoInfo.good > 0) {
            this.data.videoInfo.good --
          }
          this.setData({
            videoInfo: this.data.videoInfo
          })
        } else {
          wx.showToast({
            title: res.message || "取消点赞失败",
            icon: 'none'
          });
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
          title: "取消点赞失败",
          icon: 'none'
        });
      })
    })
  },
  // 收藏
  collectVideo() {
    modelLogin(getUrl(), (token) => {
      wx.showLoading({
        title: '加载中'
      })
      sandBox.post({
        api: `api/course/collection`,
        data: {
          type: 'course',
          id: this.data.videoInfo.id
        },
        header: {
          "authorization": token
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if (res.code === 200) {
          // 更改收藏状态
          this.data.videoInfo.is_collection_status = true
          this.setData({
            videoInfo: this.data.videoInfo
          })
          wx.showToast({
            title: "收藏成功",
            icon:"success"
          });
        } else {
          wx.showToast({
            title: res.message || "收藏失败",
            icon: 'none'
          });
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
          title: "收藏失败",
          icon: 'none'
        });
      })
    })
  },
  // 取消收藏
  cancelCollectVideo() {
    modelLogin(getUrl(), (token) => {
      wx.showLoading({
        title: '加载中'
      })
      sandBox.post({
        api: `api/course/cancelCollection`,
        data: {
          type: 'course',
          id: this.data.videoInfo.id
        },
        header: {
          "authorization": token
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if (res.code === 200) {
          // 更改收藏状态
          this.data.videoInfo.is_collection_status = false
          this.setData({
            videoInfo: this.data.videoInfo
          })
          wx.showToast({
            title: "取消收藏成功",
            icon:"success"
          });
        } else {
          wx.showToast({
            title: res.message || "取消收藏失败",
            icon: 'none'
          });
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
          title: "取消收藏失败",
          icon: 'none'
        });
      })
    })
  },
  // 点击切换
  toggleNav(e) {
    let index = e.currentTarget.dataset.index
    this.setData({
      activeIndex: Number(index)
    })
  },
  // 更新视频记录
  updateVideoHistory(e) {
    let duration = e.detail.duration
    let currentTime = e.detail.currentTime
    let _this = this
    if(timeflag) {
      // 记录一下总时长
      totalTime = duration
      timeflag = false
      // 30s记录一下历史
      timer = setTimeout(() => {
        timeflag = true
        let time = currentTime+spaceTime > duration ? currentTime : currentTime+spaceTime
        _this.setVideoHistory(time)
      }, spaceTime * 1000)
    }
    
  },
  // 课程播放完
  endVideoHistory() {
    timeflag = false
    clearTimeout(timer)
    this.setVideoHistory(-1)
  },
  // 观看历史记录
  setVideoHistory(current_time) {
    if(!this.data.playId) return false
    sandBox.post({
      api: '/api/course/history',
      data: {
        type: 'course',
        id: this.data.videoInfo.id,
        section_id: this.data.playId,
        current_time,
        total_time: totalTime
      },
      header: {
        authorization: this.data.token
      }
    }).then(res => {
      // 不操作
    }).catch(e => {
      // 失败不操作
      console.log(e)
    })
  },
  // 开通会员
  toBuy() {
    wx.redirectTo({
      url: '/pages/user/privilegeopen/privilegeopen?url=' + getUrl()
    })
  },
  // 切换
  toggle(e) {
    let toggle = e.currentTarget.dataset.toggle
    this.setData({
      [toggle]: !this.data[toggle]
    })
  },
  // 获取店铺
  getShop() {
    let _this = this
    getLocation((lat, lon) => {
      wx.showLoading({
        title: '加载中'
      })
      sandBox.get({
        api: 'api/course/shop/index',
        data: {
          page: '1',
          lat,
          lon
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if(res.status) {
          let lists = []
          if(res.data && res.data.length > 0) {
            lists = res.data.slice(0,3)
            lists.map(item => {
              item.distance = (item.distance / 1000).toFixed(1)
            })
          }
          _this.setData({
            shopList: lists
          })
        } else {
          wx.showToast({
            title: '获取线下门店失败',
            icon: 'none'
          })
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
          title: '获取线下门店失败',
          icon: 'none'
        })
      })
    })
  },
  // 分享
  onShareAppMessage(res) {
    let title = this.data.videoInfo.name ? `${this.data.videoInfo.name}课程火热进行中,点我赶紧加入` : '田知花线上教育,这么多人都在学,就差你了'
    let imageUrl = this.data.videoInfo.cover
    let id = this.data.videoInfo.id
    let url = "/pages/index/videoinfo/videoinfo?id="+id
    return {
      title: title,
      path: setShareLink(url),
      imageUrl,
      success: function (res) {
        console.log('成功', res)
      }
    }
  },
  // 立即播放
  rightNowPlay() {
    // 切换activeIndex->1
    this.setData({
      activeIndex: 1
    })
    // 判断是不是会员和视频是不是免费
    let isauth = this.data.videoInfo.is_auth_status
    let isfree = this.data.videoInfo.vip_level
    if (!isauth && isfree!==0) {
      wx.showModal({
        title: '提示信息',
        content: '您还没有开通会员,暂不能观看.是否前往开通会员?',
        cancelText: '否',
        confirmText: '是',
        success(res) {
          if (res.confirm) {
            var url = getUrl();
            wx.redirectTo({
              url: `/pages/user/privilegeopen/privilegeopen?url=${url}`
            })
          } else if (res.cancel) {
            // 取消不操作
          }
        }
      })
      return false
    }
    if(this.data.videoInfo.sections.length > 0) {
      let id = this.data.videoInfo.sections[0].id
      this.getPlayVideoInfo(id)
    } else {
      wx.showToast({
        title: '此课程下暂无视频',
        icon: 'none'
      })
    }
  },
  // 继续观看
  goOnHistory() {
    this.setData({
      initialTimeFlag: true,
      historyPlay: false
    })
  }
})