import {config,pageLogin,getUrl,sandBox,cookieStorage} from '../../../es6/myapp.js'
import Rater from '../../../component/rater/rater';

Page({
    data: {
        hasMore: true,
        init: false,
        list: [],
        page: '',
        id: ''
    },

    onLoad(e) {
        wx.showLoading({
            title: "加载中",
            mask: true
        });
        this.queryCommodityComments(e.id,1);
        this.setData({
            id: e.id
        })
    },
    // 加载更多
    onReachBottom() {
        if (this.data.hasMore) {
            var page = this.data.page + 1;
            this.queryCommodityComments(this.data.id, page)
        } else {
            wx.showToast({
                image: '../../../assets/image/error.png',
                title: '再拉也没有啦'
            });
        }
    },

    // 请求评论列表
    queryCommodityComments(id, page = 1) {
        sandBox.get({
            api: 'api/store/detail/' + id + '/comments',
            data: {
                page: page
            }
        }).then(res => {
            if (res.statusCode == 200) {
                res = res.data;
                if (res.status) {
                    var pages = res.meta.pagination;
                    var current_page = pages.current_page;
                    var total_pages = pages.total_pages;
                    this.setData({
                        [`list[${page -1}]`]: res.data,
                        init: true,
                        page: current_page,
                        hasMore: current_page < total_pages
                    });
                    res.data.forEach((v,i) => {
                        Rater.init(`${v.id}`, {
                            value: v.point,
                            disabled: true,
                            activeColor: '#EA4448',
                            fontSize: 14
                        })
                    })
                } else {
                    wx.showModal({
                        title: '',
                        content: '请求失败',
                        showCancel: false
                    })
                }
            } else {
                wx.showModal({
                    title: '',
                    content: '请求失败',
                    showCancel: false
                })
            }

            wx.hideLoading();
            this.setData({
                show: false
            })
        }, err => {
            wx.hideLoading();
            this.setData({
                show: false
            })
        })
    }
})