import {modelLogin, sandBox, getUrl, config, getLocation, callMobile, richtext} from '../../../es6/myapp.js';

Page({
  data: {
    detail: {},
    baseUrl: config.GLOBAL.baseUrl,
    shopList: [],
    toggle: false
  },
  jumpInfo(e){
    var id=e.currentTarget.dataset.id;
    wx.navigateTo({
        url: '/pages/index/shopinfo/shopinfo?id='+id
    })
  },
  onLoad() {
    this.getSystemInfo()
    this.getShop()
  },
  // 获取平台信息
  getSystemInfo() {
    let _this = this
    modelLogin(getUrl(), (token) => {
      wx.showLoading({
        title: '加载中'
      })
      sandBox.get({
        api: 'api/course/about/index',
        header: {
          authorization: token
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if(res.status) {
          res.data.content = richtext(res.data.content)
          _this.setData({
            detail: res.data
          })
        } else {
          wx.showToast({
            title: '获取平台信息失败',
            icon: 'none'
          })
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
          title: '获取平台信息失败',
          icon: 'none'
        })
      })
    })
  },
  // 获取店铺
  getShop() {
    let _this = this
    getLocation((lat, lon) => {
      wx.showLoading({
        title: '加载中'
      })
      sandBox.get({
        api: 'api/course/shop/index',
        data: {
          page: '1',
          lat,
          lon
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if(res.status) {
          let lists = []
          if(res.data && res.data.length > 0) {
            lists = res.data.slice(0,3)
            lists.map(item => {
              item.distance = (item.distance / 1000).toFixed(1)
            })
          }
          _this.setData({
            shopList: lists
          })
        } else {
          wx.showToast({
            title: '获取线下门店失败',
            icon: 'none'
          })
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
          title: '获取线下门店失败',
          icon: 'none'
        })
      })
    })
  },
  mobile(e) {
    let mobile = e.currentTarget.dataset.mobile
    callMobile(mobile)
  },
  toggle() {
    this.setData({
      toggle: !this.data.toggle
    })
  }
})