import { sandBox, getUrl, format, modelLogin } from '../../../es6/myapp.js';

var t = getApp();

Page({
  data: {
    statusBarHeight: t.globalData.height,
    activeType: '0',
    navList: [
      {
        type: '0',
        name: '未使用'
      },
      {
        type: '1',
        name: '已使用'
      },
      {
        type: '2',
        name: '已过期'
      }
    ],
    couponList: []
  },
  onLoad() {
    this.getCoupon()
  },  
  // 改变导航
  changeActiveType(e) {
    let type = e.currentTarget.dataset.type
    this.setData({
      activeType: type,
      currentPage: 1,
      couponList: []
    })
    this.getCoupon()
  },
  // 获取优惠券
  getCoupon() {
    let _this = this
    modelLogin(getUrl(), (token) => {
      wx.showLoading({
        title: '加载中'
      })
      sandBox.get({
        api: 'api/course/coupon/me',
        data: {
          type: _this.data.activeType
        },
        header: {
          authorization: token
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if (res.status) {
          // 转换时间为 yyyy-MM-dd 和 转换金额为整形
          if(res.data && res.data.length > 0) {
            res.data.map(item => {
              item.end_time = (item.end_time === '永久') ? '永久' : `${format(item.end_time, 'yyyy-MM-dd')}前`
              item.amount = item.amount ? Number(item.amount).toFixed(0) : 0
            })
          }
          _this.setData({
            couponList: (res.data && res.data.length > 0) ? _this.data.couponList.concat(res.data) : _this.data.couponList
          })
        } else {
          wx.showToast({
            title: res.message || "获取优惠券失败",
            icon: 'none'
          });
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
          title: "获取优惠券失败",
          icon: 'none'
        });
      })
    })
  }
})