import {getUrl, modelLogin, sandBox} from '../../../es6/myapp.js';

Page({
  data: {
    exchangeList: []
  },
  onLoad() {
    // 屏蔽右上角分享，只能手动分享
    wx.hideShareMenu()
    this.getList()
  },
  // 获取兑换码
  getList() {
    let _this = this
    modelLogin(getUrl(), (token) => {
      wx.showLoading({
        title: '加载中'
      })
      sandBox.get({
        api: 'api/course/vip/inviteCode',
        header: {
          authorization: token
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if(res.status) {
          _this.setData({
            exchangeList: (res.data && res.data.length > 0) ? res.data : this.data.exchangeList
          })
        } else {
          wx.showToast({
            title: '获取兑换码失败',
            icon: 'none'
          })
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
          title: '获取兑换码失败',
          icon: 'none'
        })
      })
    })
  },
  // 兑换
  toExchange(e) {
    let _this = this
    modelLogin(getUrl(), (token) => {
      let code = e.currentTarget.dataset.code
      wx.showLoading({
        title: '加载中'
      })
      sandBox.get({
          api: 'api/course/vip/inviteCodeActiveVip',
          data: {
            code
          },
          header: {
            authorization: token
          }
      }).then(res => {
          wx.hideLoading()
          res = res.data
          if(res.status) {
            wx.showToast({
                title: '兑换会员成功',
                icon: 'success',
                duration: 3000
            })
            _this.getList()
          } else {
            wx.showToast({
                title: res.message || '兑换会员失败',
                icon: 'none'
            })
          }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
            title: '兑换会员失败',
            icon: 'none'
        })
      })
    })
  },
  // 前往购买
  toBuy() {
    wx.navigateTo({
      url: '/pages/user/privilegeopen/privilegeopen'
    })
  },
  // 复制
  toCopy(e) {
    let code = e.currentTarget.dataset.code
    wx.setClipboardData({
      data: code,
      success (res) {
        
      }
    })
  },
  // 分享
  onShareAppMessage(res) {
    console.log(res)
    let code = '';
    console.log(res)
    if(res.from === "button") {
      code = res.target.dataset.code
    }
    return {
      title: '好友分享给您一张会员卡,速来领取!!!',
      path: '/pages/user/privilegeopen/privilegeopen?shareCode='+code,
      imageUrl: '../../../assets/image/share_code.png'
    }
  }
})