import {getUrl, modelLogin, sandBox, callMobile, cookieStorage} from '../../../es6/myapp.js';

Page({
  data: {
    phoneNumber: '',
    content: '',
    link: '',
    token: ''
  },
  onShow() {
    let token = cookieStorage.get('user_token')
    this.setData({
      token
    })
  },
  onLoad() {
    this.getSystemInfo()
  },
  // 拨打电话
  getPhone() {
    callMobile(this.data.phoneNumber)
  },
  // 双向绑定意见反馈内容
  bindContent(e) {
    let content = e.detail.value
    this.setData({
      content
    })
  },
  // 双向绑定联系方式
  bindLink(e) {
    let link = e.detail.value
    this.setData({
      link
    })
  },
  // 提交
  submit() {
    let _this = this
    modelLogin(getUrl(), (token) => {
      if(!_this.data.content) {
        wx.showToast({
          title: '反馈的意见不能为空',
          icon: 'none'
        })
      } else {
        wx.showLoading({
          title: '加载中'
        })
        sandBox.post({
          api: 'api/course/question',
          data: {
            question: _this.data.content,
            mobile: _this.data.link
          },
          header: {
            authorization: token
          }
        }).then(res => {
          wx.hideLoading()
          res = res.data
          if(res.status) {
            wx.showToast({
              title: '意见反馈成功',
              icon: 'success'
            })
            this.setData({
              content: '',
              link: ''
            })
          } else {
            wx.showToast({
              title: typeOf(res.message) === "string" ? res.message : '意见反馈失败',
              icon: 'none'
            })
          }
        }).catch(e => {
          wx.hideLoading()
          wx.showToast({
            title: '意见反馈失败',
            icon: 'none'
          })
        })
      }
    })
  },
  // 获取平台信息
  getSystemInfo() {
    let _this = this
    modelLogin(getUrl(), (token) => {
      wx.showLoading({
        title: '加载中'
      })
      sandBox.get({
        api: 'api/course/about/index',
        header: {
          authorization: token
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if(res.status) {
          _this.setData({
            phoneNumber: res.data.mobile
          })
        }
      }).catch(e => {
        wx.hideLoading()
      })
    })
  }
})