import { sandBox, modelLogin, getUrl } from '../../../es6/myapp.js';

Page({
  data: {
    currentPage: 1,
    messageList: [],
    messagePage: {}
  },
  onLoad() {
    this.getMessage()
  },
  // 获取数据
  getMessage() {
    wx.showLoading({
      title: '加载中'
    })
    sandBox.get({
      api: 'api/course/message/index',
      data: {
        page: this.data.currentPage
      }
    }).then(res => {
      wx.hideLoading()
      res = res.data
      if (res.status) {
        if(res.data && res.data.length > 0) {
          res.data.map(item => {
            item.created_at.date = item.created_at.date.replace(/[^.]*$/,'')
            item.created_at.date = item.created_at.date.substring(0, item.created_at.date.length - 1)
          })
        }
        this.setData({
          messageList: (res.data && res.data.length > 0) ? this.data.messageList.concat(res.data) : this.data.messageList,
          messagePage: res.meta.pagination
        })
        this.setReaded()
      } else {
        wx.showToast({
          title: "获取消息失败",
          icon: 'none'
        });
      }
    }).catch(e => {
      console.log(e)
      wx.hideLoading()
      wx.showToast({
        title: "获取消息失败",
        icon: 'none'
      });
    })
  },
  // 上拉加载
  onReachBottom() {
    if (this.data.currentPage >= this.data.messagePage.total_pages) {
      return false
    }
    // 页数++
    this.data.currentPage ++;
    this.setData({
      currentPage: this.data.currentPage
    })
    this.getMessage()
  },
  //消息已读
  setReaded() {
    modelLogin(getUrl(), (token) => {
      sandBox.post({
        api: 'api/course/message/num',
        header: {
          authorization: token
        }
      }).then(res => {
        // 不处理
      }).catch(e => {
        // 不处理
      })
    })
  }
})