import { sandBox, modelLogin, getUrl, config, changeTime } from '../../../es6/myapp.js';

Page({
  data: {
    list: [],
    currentPage: 1,
    orderPage: {}
  },
  onLoad() {
    this.getOrder()
  },
  getOrder() {
    modelLogin(getUrl(), (token) =>{
      wx.showLoading({
        title: '加载中'
      })
      sandBox.get({
        api: 'api/order/list',
        data: {
          page_index: this.data.currentPage
        },
        header: {
          authorization: token
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if(res.status) {
          this.setData({
            list: res.data,
            orderPage: res.meta.pagination
          })
        } else {
          wx.showTotal({
            title: '获取订单失败',
            icon: 'none'
          })
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showTotal({
          title: '获取订单失败',
          icon: 'none'
        })
      })
    })
  },
  // 上拉加载
  onReachBottom() {
    if (this.data.currentPage >= this.data.orderPage.total_pages) {
      return false
    }
    // 页数++
    this.data.currentPage ++;
    this.setData({
      currentPage: this.data.currentPage
    })
    this.getOrder()
  },
})