import {getUrl, modelLogin, sandBox, richtext, setShareLink} from '../../../es6/myapp.js';

Page({
  data: {
    detail: {},
    id: ''
  },
  onLoad(e) {
    if(e.id) {
      let id = e.id
      this.setData({
        id
      })
      this.getInfo(id)
    } else {
      wx.showModal({
        title: '失败',
        content: '获取会员卡详情失败,清退出小程序重试'
      })
    }
  },
  // 获取数据
  getInfo(id) {
    let _this = this
    modelLogin(getUrl(), (token) => {
      wx.showLoading({
        title: '加载中'
      })
      sandBox.get({
        api: 'api/course/vip/detail/'+id,
        header: {
          authorization: token
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if(res.status) {
          res.data.body = richtext(res.data.body)
          _this.setData({
            detail: res.data
          })
        } else {
          wx.showToast({
            title: '获取会员详情失败',
            icon: 'none'
          })
        }
      }).catch(e => {
        console.log(e)
        wx.hideLoading()
        wx.showToast({
          title: '获取会员详情失败',
          icon: 'none'
        })
      })
    })
  },
  // 开通会员(支付)
  buyVip() {
    let _this = this
    modelLogin(getUrl(), (token) => {
      let id = _this.data.id
      wx.showLoading({
        title: '加载中'
      })
      sandBox.post({
        api: 'api/course/vip/pay',
        data: {
          id:  id
        },
        header: {
          "authorization": token
        }
      }).then(res => {
        res = res.data
        if (res.status) {
          // 获取到支付信息,调用微信支付
          wx.requestPayment({
            timeStamp: String(res.data.timeStamp),
            nonceStr: res.data.nonceStr,
            package: res.data.package,
            signType: res.data.signType,
            paySign: res.data.paySign,
            success:(result => {
              wx.showToast({
                title: "支付成功",
                icon: 'success',
                duration: 3000
              });
              // 跳转到会员中心
              wx.redirectTo({
                url: '/pages/user/vipequity/vipequity?id='+id
              })
            }),
            fail:(error => {
              console.log(error)
              wx.showToast({
                title: "开通会员卡失败",
                icon: 'none'
              });
            })
          })
        } else {
          wx.showToast({
            title: res.message || "开通会员卡失败",
            icon: 'none'
          });
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
          title: "开通会员卡失败",
          icon: 'none'
        });
      })
    })
  },
  // 分享
  onShareAppMessage(res) {
    return {
      title: '田知花少儿教育,你确定不来加入吗?',
      path: setShareLink('/pages/index/index/index'),
      imageUrl: '../../../assets/image/share.jpg'
    }
  }
})