import { sandBox, getUrl, modelLogin, setShareLink } from '../../../es6/myapp.js';

Page({
  data: {
    vipList: []
  },
  onShow() {
    this.getVipList()
  },
  jump(e){
    var url=e.currentTarget.dataset.url;
    wx.navigateTo({
        url: url
    })
  },
  // 获取会员卡列表
  getVipList() {
    let _this = this
    modelLogin(getUrl(), (token) => {
      wx.showLoading({
        title: '加载中'
      })
      sandBox.get({
        api: 'api/course/vip',
        header: {
          authorization: token
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if (res.status) {
          _this.setData({
            vipList: res.data
          })
        } else {
          wx.showToast({
            title: "获取会员卡失败",
            icon: 'none'
          });
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
          title: "获取会员卡失败",
          icon: 'none'
        });
      })
    })
  },
  // 开通会员(支付)
  buyVip(e) {
    let _this = this
    modelLogin(getUrl(), (token) => {
      let id = e.currentTarget.dataset.id
      wx.showLoading({
        title: '加载中'
      })
      sandBox.post({
        api: 'api/course/vip/pay',
        data: {
          id:  id
        },
        header: {
          "authorization": token
        }
      }).then(res => {
        res = res.data
        if (res.status) {
          // 获取到支付信息,调用微信支付
          wx.requestPayment({
            timeStamp: String(res.data.timeStamp),
            nonceStr: res.data.nonceStr,
            package: res.data.package,
            signType: res.data.signType,
            paySign: res.data.paySign,
            success:(result => {
              wx.showToast({
                title: "支付成功",
                icon: 'success',
                duration: 3000
              });
              // 跳转到会员中心
              wx.navigateTo({
                url: '/pages/user/vipequity/vipequity?id='+id
              })
            }),
            fail:(error => {
              console.log(error)
              wx.showToast({
                title: "开通会员卡失败",
                icon: 'none',
                duration: 3000
              });
            })
          })
        } else {
          wx.showToast({
            title: res.message || "开通会员卡失败",
            icon: 'none',
            duration: 3000
          });
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
          title: "开通会员卡失败",
          icon: 'none',
          duration: 3000
        });
      })
    })
  },
  // 查看会员卡详情
  seeVipInfo(e) {
    let item = e.currentTarget.dataset.info
    if(item.user_vip) { // 已购买
      wx.navigateTo({
        url: '/pages/user/vipequity/vipequity?id='+item.id
      })
    } else {  // 未购买
      wx.navigateTo({
        url: '/pages/user/privilege/privilege?id='+item.id
      })
    }
  },
  // 分享
  onShareAppMessage(res) {
    return {
      title: '田知花少儿教育,你确定不来加入吗?',
      path: setShareLink('/pages/index/index/index'),
      imageUrl: '../../../assets/image/share.jpg'
    }
  }
})