import { sandBox, modelLogin, getUrl } from '../../../es6/myapp.js';

Page({
  data: {
    buyList: [],
  },
  onLoad() {
    this.getBuyList()
  },
  // 获取购买记录
  getBuyList() {
    let _this = this
    modelLogin(getUrl(), (token) => {
      wx.showLoading({
        title: '加载中'
      })
      sandBox.get({
        api: 'api/course/order/me',
        header: {
          authorization: token
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if(res.status) {
          _this.setData({
            buyList: (res.data && res.data.length > 0) ? res.data : [] 
          })
        } else {
          wx.showToast({
            title: res.message || '获取购买记录失败',
            icon: 'none'
          })
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
          title: '获取购买记录失败',
          icon: 'none'
        })
      })
    }) 
  },
  // 前往购买
  toBuy() {
    wx.navigateTo({
      url: '/pages/user/privilegeopen/privilegeopen'
    })
  }
})