import {getUrl, modelLogin, sandBox, format, setShareLink} from '../../../es6/myapp.js';
Page({
  data: {
    detail: {}
  },
  onLoad(e) {
    if(e.id) {
      this.getDetail(e.id)
    }
  },
  // 获取数据
  getDetail(id) {
    modelLogin(getUrl(), (token) => {
      wx.showLoading({
        title: '加载中'
      })
      sandBox.get({
        api: 'api/course/vip/detail/'+id,
        header: {
          authorization: token
        }
      }).then(res => {
        wx.hideLoading()
        res = res.data
        if(res.status) {
          res.data.hopa_vip_end_time = res.data.hopa_vip_end_time ? format(res.data.hopa_vip_end_time, 'yyyy-MM-dd') : ''
          this.setData({
            detail: res.data
          })
        } else {
          wx.showToast({
            title: typeof res.message === 'string' ? res.message : '获取会员详情失败',
            icon: 'none'
          })
        }
      }).catch(e => {
        wx.hideLoading()
        wx.showToast({
          title: '获取会员详情失败',
          icon: 'none'
        })
      })
    })
  },
  // 返回
  back() {
    wx.navigateBack()
  },
  // 分享
  onShareAppMessage(res) {
    return {
      title: '田知花少儿教育,你确定不来加入吗?',
      path: setShareLink('/pages/index/index/index'),
      imageUrl: '../../../assets/image/share.jpg'
    }
  }
})